/*
This test is part of the NIST Source Code Analysis Tool Assessment Test Suite
* Test ID: integrity/improper_dynamic_memory_management/cpp/01

This software was developed at the National Institute of Standards and
Technology by employees of the Federal Government in the course of their
official duties. Pursuant to title 17 Section 105 of the United States
Code this software is not subject to copyright protection and is in the
public domain. NIST assumes no responsibility whatsoever for its use by
other parties, and makes no guarantees, expressed or implied, about its
quality, reliability, or any other characteristic.
*/

#include <stdlib.h>
#include "TestRunner.h"
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <limits.h>
#include <iostream>

TestRunner::TestRunner()
{
}


int TestRunner::run(unsigned int n)
{
	char *buf;
	int i;
	buf = (char *)malloc(n * sizeof (char));  /* BAD.. potential unlimited
											  heap overflow */
	if(!buf)
		return (1);
	for(i = 0; i < n; i++)
		buf[i] = i;		
	while(i-- > 0)
		printf("%x ", buf[i]);	
	printf("\n");
	free(buf);
	return (0);
}

