/* 
 * This test is part of the NIST Source Code Analysis Tool Assessment Test Suite
 * Test ID: modularity_and_programming/no_formal_exception_handling/cpp/01
 *
 * This software was developed at the National Institute of Standards and
 * Technology by employees of the Federal Government in the course of their
 * official duties. Pursuant to title 17 Section 105 of the United States
 * Code this software is not subject to copyright protection and is in the
 * public domain. NIST assumes no responsibility whatsoever for its use by
 * other parties, and makes no guarantees, expressed or implied, about its
 * quality, reliability, or any other characteristic.
 *
 */


#include <iostream>
#include "TestRunner.h"
#include "Util.h"

TestRunner::TestRunner()
{
}

int TestRunner::run(int argc, char ** argv)
{
	Util u;
	int returnVal = u.getResources();
	switch (returnVal){
		case 1:
		{
			printf("\nCould not dynamically allocate memory\n");
			break;
		}
		case 2:
		{
			printf("\nCould not open file\n");
			break;
		}
		case 3:
		{
			printf("\nCould not read file content\n");
			break;
		}
		default:
		printf("\n All resources allocated\n");
		return(returnVal);
	}
	return 0;
}


