/* 
 * This test is part of the NIST Source Code Analysis Tool Assessment Test Suite
 * Test ID: other_coding_conventions/improper_use_of_low_level_langauge/cpp/01
 *
 * This software was developed at the National Institute of Standards and
 * Technology by employees of the Federal Government in the course of their
 * official duties. Pursuant to title 17 Section 105 of the United States
 * Code this software is not subject to copyright protection and is in the
 * public domain. NIST assumes no responsibility whatsoever for its use by
 * other parties, and makes no guarantees, expressed or implied, about its
 * quality, reliability, or any other characteristic.
 *
 */

#include <iostream>
#include "TestRunner.h"

TestRunner::TestRunner()
{
}

int TestRunner::run(int argc, char ** argv)
{
	int a=10, b=0;
	swap(a,b); 
	return 0 ;
}

int TestRunner::swap (int a, int b)
{
	#ifdef CLCOMPILER
	__asm
	{
		mov eax, a   
		mov b, eax  ; swap a to b
	}
	printf_s("%d\n", b);
	#endif
	
	#ifdef GNUCOMPILER
	asm ("movl %1, %%eax; movl %%eax, %0;" :"=r"(b)  :"r"(a) :"%eax" );   
	__asm ("movl %1, %%eax; movl %%eax, %0;" :"=r"(b)  :"r"(a) :"%eax" );     
	__asm__ ("movl %1, %%eax; movl %%eax, %0;" :"=r"(b)  :"r"(a) :"%eax" ); 
	printf("%d\n", b);
	return b;
	#endif
	
	return (0);
	
}




