/* 
 * This test is part of the NIST Source Code Analysis Tool Assessment Test Suite
 * Test ID: other_coding_conventions/no_vote_count_overflow_controls/cpp/14
 *
 * This software was developed at the National Institute of Standards and
 * Technology by employees of the Federal Government in the course of their
 * official duties. Pursuant to title 17 Section 105 of the United States
 * Code this software is not subject to copyright protection and is in the
 * public domain. NIST assumes no responsibility whatsoever for its use by
 * other parties, and makes no guarantees, expressed or implied, about its
 * quality, reliability, or any other characteristic.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include "Util.h"
#include <limits.h>

Util::Util ()
{
}

int Util::left_shift(int int1, int int2)
{
	int result;
	/* ok, check performed before shift*/	
	left_shiftCheck (int1, int2);
	result = int1 << int2;
	return result;
}

int Util::left_shiftCheck (int int1, int int2)
{
	if ( (int1 < 0) || (int2 < 0) || (int2 >= sizeof(int)*CHAR_BIT) || int1 > (INT_MAX >> int2) ) {
		printf ("integer overflow/n");
		exit (1);
	}
	else
	return (0);
}
